<script setup lang="ts">
import { automationsStore } from "~/stores/automations"
import DragDrop from "~/components/DragDrop.vue"

const router = useRouter()
const store = automationsStore()

const orderOfRequests = ref("")
const showModal = ref(false)
const apiCallData = ref({})

const automation = computed(() => {
  const id = router.currentRoute.value.params.id
  if (typeof id === "string") {
    return store.automations[id]
  }
})

const validate = async () => {
  const response = await fetch("http://localhost:8080/run/1", {
    method: "POST",
    headers: {
      "Content-Type": "application/json",
    },
    body: JSON.stringify({
      data: {
        orderOfRequests: orderOfRequests.value,
      },
    }),
  })
    .then(response => response.json())
    .then((response) => {
      showModal.value = true
      apiCallData.value = response.data.manufacturers
      console.log(response.data.manufacturers)
      return response
    })
}

const updateValue = (newV) => {
  console.log("newV: ", newV)
}
</script>

<template>
  <div class="flex flex-1 flex-col bg-white">
    <div
      class="sticky z-10 top-0 flex flex-row justify-between items-center p-4 md:p-6 border-b bg-[#FFF] border-[#E6E6E5]"
    >
      <div class="flex flex-1 items-center gap-4">
        <div
          class="flex py-2 cursor-pointer"
          @click="router.push({ name: 'automations' })"
        >
          <div
            i="carbon-arrow-left"
            class="scale-120"
          />
        </div>
        <span class="flex flex-1 text-[#262626] text-xl">
          <!-- TODO fix this -->
          <!-- {{ automation.name }} -->
          automation 1
        </span>
        <div class="flex gap-2 text-[#19181E] text-sm" />
      </div>
      <button
        class="ml-4 px-4 py-2 text-sm font-semibold text-white bg-[#262626] rounded-md"
        @click="validate"
      >
        Run
      </button>
    </div>
    <div
      class="flex flex-col gap-4 p-4 w-full"
    >
      <DragDrop @updateValue="updateValue" />
    </div>
    <div v-if="showModal" class="fixed inset-0 z-10 flex items-center justify-center">
      <div class="absolute inset-0 bg-gray-900 opacity-75" />
      <div class="bg-white rounded-lg p-6 z-100">
        <h2 class="text-lg font-medium mb-6 mt-6">
          Manufacturer of current payload:
        </h2>
        <ul>
          <li v-for="manufacturer in apiCallData" :key="manufacturer">
            {{ manufacturer }}
          </li>
        </ul>
        <button class="mt-4 px-4 py-2 text-sm font-semibold text-white bg-[#262626] rounded-md" @click="showModal = false">
          Close
        </button>
      </div>
    </div>
  </div>
</template>

<style>
.container {
  display: flex;
  justify-content: center;
  align-items: center;
  margin-top: 50px;
}

.box {
  width: 100px;
  height: 100px;
  margin: 0 30px;
}

.box1 {
  background-color: #033b0b;
}

.box2 {
  background-color: #033b0b;
}
</style>

<route lang="yaml">
meta:
  layout: home
  requiresAuth: true
</route>
